=== debian/changelog ===
intel-compute-runtime (20.44.18297-1) unstable; urgency=medium

  * New upstream release.
  * Migrate to llvm 11.
  * control: Bump depends on IGC.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 13 Nov 2020 23:49:23 +0200

intel-compute-runtime (20.37.17906-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump libigc-dev/libigdfcl-dev build-depends.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 22 Sep 2020 19:07:08 +0300
