=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?(\d[\d.]*)\.tar\.gz%intel-compute-runtime-$1.tar.gz%" \
   https://github.com/intel/compute-runtime/tags \
   (?:.*?/)?(\d[\d.]*)\.tar\.gz
